<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\HodnotenieEmisnejKontrolyEnum;

/**
 * Class ZoznamPoctuKontrolPodlaHodnotenia
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class ZoznamPoctuKontrolPodlaHodnotenia extends ZoznamPoctuKontrolAbstract implements ZoznamPoctuKontrol
{
    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrol $pocetKontrol
     *
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\ZoznamPoctuKontrolPodlaHodnotenia
     */
    public function add(PocetKontrol $pocetKontrol): self
    {
        $addNewRecord = true;

        if (!$pocetKontrol instanceof PocetKontrolPodlaHodnotenia) {
            throw new InvalidArgumentException(
                sprintf(
                    'Ocakava sa instancia triedy %s, vtupny atribut je instancie %s',
                    PocetKontrolPodlaHodnotenia::class,
                    get_class($pocetKontrol)
                )
            );
        }

        array_walk(
            $this->items,
            function (?PocetKontrolPodlaHodnotenia &$pocetKontrolPodlaHodnotenia, int $index) use ($pocetKontrol, &$addNewRecord) {
                if ($pocetKontrolPodlaHodnotenia->equalsHodnotenie($pocetKontrol)) {
                    $pocetKontrolPodlaHodnotenia = $pocetKontrolPodlaHodnotenia->navysitPocet($pocetKontrol);
                    $addNewRecord = false;
                }
            }
        );

        if ($addNewRecord) {
            $this->items[] = $pocetKontrol;
        }

        return new self($this->items);
    }

    /**
     * @param array $udaje
     *
     * @return self
     */
    public static function createFromArray(array $udaje): self
    {
        $zoznam = new self();

        foreach ($udaje as $udaj) {
            $zoznam->add(new PocetKontrolPodlaHodnotenia(
                HodnotenieEmisnejKontrolyEnum::from(mb_strtoupper($udaj['hodnotenie'])),
                (int)$udaj['pocet']
            ));
        }

        return $zoznam;
    }
}
